unit common;

interface

uses   SysUtils, StdCtrls, Classes;

function MakeTarget( const DirName: String ): String;
function AddUniqueFile( SL: TStringList; const FName: String ): Boolean;
function CommonTarget( TLB: TStringList ): String;

var
   FTarget:         String;
   FTemplate:       String;

implementation

{===============================================================}
{===============================================================}
function MakeTarget( const DirName: String ): String;
begin
     Result := DirName;
     if ( DirName[Length(DirName)] <> '\') then
       Result := DirName + '\';
end;

{===============================================================}
{===============================================================}
function AddUniqueFile( SL: TStringList; const FName: String ): Boolean;
var
  i:         Integer;
  TheFile:   String;
begin
     Result := True;
     TheFile := LowerCase(FName);
     for i := 0 to SL.Count-1 do
       begin
       if (CompareText(TheFile,SL[i]) = 0) then
         begin
         Result := False;
         break;
         end;
       end;

     if (Result = True) then
       SL.Add(TheFile);
end;

{===============================================================}
{===============================================================}
function CommonTarget( TLB: TStringList ): String;
var
   i:           Integer;
   Len:         Integer;
   FoundTarget: Boolean;
   Tmp:         String;
   Tst:         String;
begin
     Result := '';
     if (TLB.Count > 0) then
       begin
       Tmp := TLB[0];
       FoundTarget := False;
       while not FoundTarget do
         begin
         FoundTarget := True;
         Tmp := ExtractFilePath(Tmp);
         if (Length(Tmp) > 3) then
           Tmp := Copy(Tmp,1,Length(Tmp)-1);
         Len := Length(Tmp);
         for i := 0 to TLB.Count-1 do
           begin
           Tst := Copy(TLB[i],1,Len);
           if (CompareText(Tmp,Tst) = 0) then
             Continue;
           FoundTarget := False;
           break;
           end;
         end;

       Result := MakeTarget(Tmp);
       end;
end;

end.
